commit e759655c22ad154f93fb7f76b16d19a87a58384c
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Tue May 15 19:42:36 2018 +0200

    ref #7362 Internalize request constants

diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestBroader.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestBroader.java
index 41661f127..47bd6af5e 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestBroader.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestBroader.java
@@ -29,7 +29,7 @@ public class RequestBroader extends AbstractTerminologyServiceRequest{
 
     @Override
     protected String getServiceUri() {
-        return TerminologyServiceConstants.BROADER_SERVICE_URL;
+        return "broader";
     }
 
     @Override
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestHierarchy.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestHierarchy.java
index 1c7b9333c..bd915ae23 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestHierarchy.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestHierarchy.java
@@ -27,7 +27,7 @@ public class RequestHierarchy extends AbstractTerminologyServiceRequest{
 
     @Override
     protected String getServiceUri() {
-        return TerminologyServiceConstants.HIERARCHY_SERVICE_URL;
+        return "hierarchy";
     }
 
     /**
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestNarrower.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestNarrower.java
index 2a9af05be..4d0a9c3be 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestNarrower.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestNarrower.java
@@ -29,7 +29,7 @@ public class RequestNarrower extends AbstractTerminologyServiceRequest{
 
     @Override
     protected String getServiceUri() {
-        return TerminologyServiceConstants.NARROWER_SERVICE_URL;
+        return "narrower";
     }
 
     @Override
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestSuggest.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestSuggest.java
index 0b09f034e..66f6ff3e9 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestSuggest.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/RequestSuggest.java
@@ -27,7 +27,7 @@ public class RequestSuggest extends AbstractTerminologyServiceRequest{
 
     @Override
     protected String getServiceUri() {
-        return TerminologyServiceConstants.SUGGEST_SERVICE_URL;
+        return "suggest";
     }
 
     /**
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/TerminologyServiceConstants.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/TerminologyServiceConstants.java
index 9a598ea7c..af38fdf37 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/TerminologyServiceConstants.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/requests/TerminologyServiceConstants.java
@@ -15,13 +15,6 @@ package eu.etaxonomy.taxeditor.view.webimport.termimport.requests;
  */
 public interface TerminologyServiceConstants {
 
-    public static final String NARROWER_SERVICE_URL = "narrower";
-    public static final String BROADER_SERVICE_URL = "broader";
-    public static final String SUGGEST_SERVICE_URL = "suggest";
-    public static final String SEARCH_SERVICE_URL = "search";
-    public static final String HIERARCHY_SERVICE_URL = "hierarchy";
-    public static final String TERM_SERVICE_URL = "term";
-
     public static final String ATTR_QUERY = "query";
     public static final String ATTR_URI = "uri";
     public static final String ATTR_LIMIT = "limit";